--------------------------------------------------------------------------
--
--  BENCHMARK       : GCD
--
--------------------------------------------------------------------------

PACKAGE testbench_pack IS
  CONSTANT SIZE : INTEGER := 8;
END testbench_pack;

LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.NUMERIC_BIT.ALL;
USE WORK.testbench_pack.ALL;

entity testbench is
-- empty
end;

architecture testbench of testbench is
  component gcd8
  port (
    clock     : in bit;
    reset     : in bit;
    xi        : in UNSIGNED (SIZE-1 DOWNTO 0);
    yi        : in UNSIGNED (SIZE-1 DOWNTO 0);
    ou        : out UNSIGNED (SIZE-1 DOWNTO 0) 
  );
  end component ;

  signal clock_in_port : bit;
  signal reset_in_port : bit;
  signal xi_in_port    : UNSIGNED (SIZE-1 DOWNTO 0);
  signal yi_in_port    : UNSIGNED (SIZE-1 DOWNTO 0);
  signal ou_out_port   : UNSIGNED (SIZE-1 DOWNTO 0);

  for all : gcd8 use entity work.gcd8(gcd8) ;

  begin
  INST1 : gcd8 port map (
                clock => clock_in_port,
				reset => reset_in_port,
				xi    => xi_in_port, 
                yi    => yi_in_port,
                ou    => ou_out_port
                );

  process

  begin

-- ****************************************** 
-- *                                        * 
-- *           TEST VECTORS                 * 
-- *                                        * 
-- ****************************************** 
--
-- Pattern #0
   xi_in_port     <= "00001000";
   yi_in_port     <= "00000100";
   reset_in_port  <= '1';
   clock_in_port  <= '0'; -- clock is a dummy port
   wait for 100 ns;
   assert (ou_out_port = "00000000") report "Assert 0 : < ou /= 0 >" severity warning;
 
   assert ( false ) report " :) " severity warning;
   assert ( false ) report " :P " severity warning;

 end process;

end testbench;
